---
title: Create Sign-On Policy Action (LOGIN)
description: The POST {{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions operation creates a new sign-on policy action resource. The priority property specifies the order in which this action (and its conditions) is evaluated when evaluating the policy. Property values range from 1 to {maxInt}. The action with a priority value of 1 is evaluated first.
component: pingone-api
page_id: pingone-api:platform:sign-on-policies/sign-on-policy-actions/create-sign-on-policy-action-login
canonical_url: https://developer.pingidentity.com/pingone-api/platform/sign-on-policies/sign-on-policy-actions/create-sign-on-policy-action-login.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create Sign-On Policy Action (LOGIN)

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions
```

The `POST {{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions` operation creates a new sign-on policy action resource. The `priority` property specifies the order in which this action (and its conditions) is evaluated when evaluating the policy. Property values range from `1` to `{maxInt}`. The action with a `priority` value of `1` is evaluated first.

|   |                                                                                                                                                                                                                                                                               |
| - | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | The `condition` property for the sign-on policy action specifies the conditions associated with the action. At least one condition must be met to execute the action. If the `conditions` attribute is omitted from the sign-on policy action, the action is always executed. |

The sample shows the a sign-on policy action with the `type` attribute set to `LOGIN`.

### Prerequisites

* [Sign-on Policy Actions](../sign-on-policy-actions.html)

* [Create a sign-on policy](../sign-on-policies-1/create-sign-on-policy.html) to get a `policyID` for the endpoint.

> **Collapse: Request Model**
>
> | Property            | Type    | Required? |
> | ------------------- | ------- | --------- |
> | `condition.ipRange` | String  | Optional  |
> | `priority`          | Integer | Required  |
> | `recovery.enabled`  | Boolean | Optional  |
> | `type`              | String  | Required  |
>
> Refer to the [Sign-on policy actions base data model](../sign-on-policy-actions.html#sign-on-policy-actions-base-data-model) for full property descriptions.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "priority": 10,
    "type": "LOGIN",
    "condition": {
        "not": {
            "ipRange": [
                "10.1.1.1/8",
                "10.0.0.0/8"
            ],
            "contains": "${flow.request.http.remoteIp}"
        }
    },
    "recovery": {
        "enabled": true
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "priority": 10,
    "type": "LOGIN",
    "condition": {
        "not": {
            "ipRange": [
                "10.1.1.1/8",
                "10.0.0.0/8"
            ],
            "contains": "${flow.request.http.remoteIp}"
        }
    },
    "recovery": {
        "enabled": true
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""priority"": 10," + "\n" +
@"    ""type"": ""LOGIN""," + "\n" +
@"    ""condition"": {" + "\n" +
@"        ""not"": {" + "\n" +
@"            ""ipRange"": [" + "\n" +
@"                ""10.1.1.1/8""," + "\n" +
@"                ""10.0.0.0/8""" + "\n" +
@"            ]," + "\n" +
@"            ""contains"": ""${flow.request.http.remoteIp}""" + "\n" +
@"        }" + "\n" +
@"    }," + "\n" +
@"    ""recovery"": {" + "\n" +
@"        ""enabled"": true" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions"
  method := "POST"

  payload := strings.NewReader(`{
    "priority": 10,
    "type": "LOGIN",
    "condition": {
        "not": {
            "ipRange": [
                "10.1.1.1/8",
                "10.0.0.0/8"
            ],
            "contains": "${flow.request.http.remoteIp}"
        }
    },
    "recovery": {
        "enabled": true
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "priority": 10,
    "type": "LOGIN",
    "condition": {
        "not": {
            "ipRange": [
                "10.1.1.1/8",
                "10.0.0.0/8"
            ],
            "contains": "${flow.request.http.remoteIp}"
        }
    },
    "recovery": {
        "enabled": true
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"priority\": 10,\n    \"type\": \"LOGIN\",\n    \"condition\": {\n        \"not\": {\n            \"ipRange\": [\n                \"10.1.1.1/8\",\n                \"10.0.0.0/8\"\n            ],\n            \"contains\": \"${flow.request.http.remoteIp}\"\n        }\n    },\n    \"recovery\": {\n        \"enabled\": true\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "priority": 10,
    "type": "LOGIN",
    "condition": {
      "not": {
        "ipRange": [
          "10.1.1.1/8",
          "10.0.0.0/8"
        ],
        "contains": "${flow.request.http.remoteIp}"
      }
    },
    "recovery": {
      "enabled": true
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "priority": 10,
    "type": "LOGIN",
    "condition": {
      "not": {
        "ipRange": [
          "10.1.1.1/8",
          "10.0.0.0/8"
        ],
        "contains": "${flow.request.http.remoteIp}"
      }
    },
    "recovery": {
      "enabled": true
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions"

payload = json.dumps({
  "priority": 10,
  "type": "LOGIN",
  "condition": {
    "not": {
      "ipRange": [
        "10.1.1.1/8",
        "10.0.0.0/8"
      ],
      "contains": "${flow.request.http.remoteIp}"
    }
  },
  "recovery": {
    "enabled": True
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "priority": 10,\n    "type": "LOGIN",\n    "condition": {\n        "not": {\n            "ipRange": [\n                "10.1.1.1/8",\n                "10.0.0.0/8"\n            ],\n            "contains": "${flow.request.http.remoteIp}"\n        }\n    },\n    "recovery": {\n        "enabled": true\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "priority": 10,
  "type": "LOGIN",
  "condition": {
    "not": {
      "ipRange": [
        "10.1.1.1/8",
        "10.0.0.0/8"
      ],
      "contains": "\${flow.request.http.remoteIp}"
    }
  },
  "recovery": {
    "enabled": true
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"priority\": 10,\n    \"type\": \"LOGIN\",\n    \"condition\": {\n        \"not\": {\n            \"ipRange\": [\n                \"10.1.1.1/8\",\n                \"10.0.0.0/8\"\n            ],\n            \"contains\": \"${flow.request.http.remoteIp}\"\n        }\n    },\n    \"recovery\": {\n        \"enabled\": true\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/signOnPolicies/f73594d5-9b2e-45bf-abec-3f629ab53721/actions/2ae554aa-02ac-4056-bb07-da71cc11815c"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "signOnPolicy": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/signOnPolicies/f73594d5-9b2e-45bf-abec-3f629ab53721"
        }
    },
    "id": "2ae554aa-02ac-4056-bb07-da71cc11815c",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "type": "LOGIN",
    "condition": {
        "not": {
            "ipRange": [
                "10.1.1.1/8",
                "10.0.0.0/8"
            ],
            "contains": "${flow.request.http.remoteIp}"
        }
    },
    "signOnPolicy": {
        "id": "f73594d5-9b2e-45bf-abec-3f629ab53721"
    },
    "priority": 10,
    "registration": {
        "enabled": false
    },
    "recovery": {
        "enabled": true
    }
}
```
